*** VFP Form -> HTML conversion program
***
*** Note: This is VERY preliminary  and only basic forms will
***       work with this stuff at this time.


#IF .T.
   LOCAL oForm, IF
   #INCLUDE WCONNECT.H

   IF ATC("5.0",VERSION()) = 0
      wait window "This tool requires VFP 5.0..."
      RETURN
   ENDIF
   
   DO ..\..\WCONNECT  && Load Web Connection classes

   SET PROCEDURE TO HTMLCTLS ADDITIVE

   DO FORM GUEST

   RETURN
#ENDIF

#IF .F.
   loHTML=CREATE("wwHTML","TEST.HTM")

   *** Open table
   IF !USED("Guest")
      USE GUEST IN 0
   ENDIF
   SELE GUEST

   *** Now run and load the form into memory
   DO FORM GUEST NAME oForm LINKED NOSHOW

   *** Pass in Form and HTML object
   oHTMLForm=CREATE("HTMLForm",oForm,loHTML)
   oHTMLForm.lCenterTable=.T.
   oHTMLForm.nTableBorder=1

   oHTMLForm.lShowCompleteForm=.T.
   oHTMLForm.cFormAction="/cgi-win/wwcgi.dll?wwDemo~VFP2HTMLForm"

   *-*SCAN
   *-*   oForm.Refresh  && Have to refresh the Form in order to update fields
   oHTMLForm.ShowContainer()
   *-*ENDSCAN

   *loHTML.SendLn([</FORM>])

   *loHTML.HTMLFooter()

   loHTML.SEND(oHTMLForm.GetOutput())
   RELEASE oHTMLForm
   RELEASE loHTML
   *    MODI COMM TEST.HTM

   *** Show the page in the browser
   GoUrl(CURDIR()+"test.htm")

   DO WCONNECT WITH "UNLOAD"
   RELEASE PROCEDURE HTMLCTLS

   RETURN
#ENDIF

*************************************************************
DEFINE CLASS HTMLForm AS Custom
*************************************************************
***   Version: .85a
***    Author: Rick Strahl
***            (c) West Wind Technologies, 1996
***   Contact: (541) 386-2087  / rstrahl@west-wind.com
***  Modified: 11/15/96
***
***  Function: Takes a Visual FoxPro container object that's
***            already loaded in memory and creates an
***            HTML representation of the container.
***
***     Notes: Does not create <FORM> nor is any logic
***            attached to buttons or links. The idea is
***            that the form is simply displayed AS IS
***            with the surrounding Web Connection/FoxISAPI
***            code generating the page headers and FORM
***            tags around the displayed form. This allows
***            max flexibility and the ability to combine
***            multiple containers into one HTML form.
***
***            Form is displayed as a table that mimicks
***            a VFP Form with a title bar.
***
***            Top level container will step through any
***            containers and display them recursively.
***
***            Not supported:
***                *  Grids
***                *  PageFrames
***                *  Lists (Combos work though)
***                *  Spinners
***                *  Images
***                *  Anything OLE
*************************************************************

*** Custom Properties

*** Objects passed in
oContainer=.NULL.    && Form or other object to HTML
oHTML=.NULL.         && HTML object to gen output
lButtonObject=.F.

nTableBorder=1
nFieldBorder=0

lCenterTable=.T.

lShowCompleteForm=.F.
cFormAction=""
cFormMethod="POST"
cContentType="NONE"

*** Stock Properties

************************************************************************
* HTMLForm :: Init
*********************************
***  Function: Sets up the Container and HTML objects.
***    Assume: HTML object is passed in as a reference. Note that
***            any updates here reflect on the calling object.
***      Pass: loContainer  -   a VFP container object (form)
***            loHTML       -   (Optional) HTML Object
************************************************************************
FUNCTION INIT
LPARAMETER loContainer, loHTML, llButtons

IF TYPE("loContainer") #"O"
   WAIT WINDOW NOWAIT "Invalid Container object passed..."
   RETURN
ENDIF

THIS.oContainer=loContainer

IF TYPE("loHTML") # "O"
   THIS.oHTML = CREATE("wwHTMLString")
ELSE
   THIS.oHTML = loHTML
ENDIF

THIS.lButtonObject=llButtons

ENDFUNC
* Init

************************************************************************
* HTMLForm :: ShowContainer
*********************************
***  Function: Runs through the container and displays the item
***            collection as HTML in table. Note no attempt at logic
***            attachment to buttons is performed! That code should
***            generated by the wrapper code.
***      Pass: llNowShowAsForm -  Show as individual table element.
***                               Don't force try to force as a form
***    Return:
************************************************************************
FUNCTION ShowContainer
LPARAMETER llNoShowAsForm
LOCAL lcCaption, loContainer, llMaster, loHTML, lcobjAlias, lcOldAlias,;
   x,lnCols, loObject, lcObject

loContainer=THIS.oContainer

loHTML=THIS.oHTML

lcOldAlias=ALIAS()

llMaster=.F.
IF !llNoShowAsForm
   llMaster=.T.
ENDIF

lcobjAlias=SYS(2015)

*** Grab all items on the container in order to sort by TOP/LEFT
SELE 0
CREATE CURSOR (lcobjAlias) (oName C (50) ,;
   TOP N (6,0),;
   LEFT N (6,0),;
   PARENT C (50) )

*** Scalemode to Foxels so we have some leeway with alignment
IF TYPE("loContainer.scalemode")="N"
   loContainer.SCALEMODE=0
ENDIF

*** Collect items and store in cursor
IF !THIS.lButtonObject
   FOR EACH oObject IN loContainer.OBJECTS
      INSERT INTO (lcobjAlias) (oName,TOP,LEFT,PARENT) VALUES ;
         (oObject.NAME, IIF(TYPE("oObject.top")="N",oObject.TOP,-1),;
         IIF(TYPE("oObject.Left")="N",oObject.LEFT,-1),;
         IIF(TYPE("oObject.parent.name")="C",oObject.PARENT.NAME,"") )
   ENDFOR
ELSE
   FOR EACH oObject IN loContainer.BUTTONS
      INSERT INTO (lcobjAlias) (oName,TOP,LEFT,PARENT) VALUES ;
         (oObject.NAME, IIF(TYPE("oObject.top")="N",oObject.TOP,-1),;
         IIF(TYPE("oObject.Left")="N",oObject.LEFT,-1),;
         IIF(TYPE("oObject.parent.name")="C",oObject.PARENT.NAME,"") )
   ENDFOR
ENDIF

*** And sort by TOP/LEFT
INDEX ON TOP * 1000 + LEFT TAG Location

*** Find the largest number of columns required on the container
SELECT COUNT(*) AS COUNT FROM (lcobjAlias) GROUP BY TOP INTO CURSOR TTemp
CALCULATE MAX(COUNT) TO lnMaxCols
USE IN TTemp

SELE (lcobjAlias)

IF THIS.lShowCompleteForm
   lcCaption=IIF(TYPE("loContainer.Caption")="C",loContainer.CAPTION,"")
   loHTML.HTMLHeader(,lcCaption,,THIS.cContentType)

   loHTML.SendLn([<FORM ACTION="]+THIS.cFormAction+[" METHOD="]+THIS.cFormMethod+[">])
ENDIF


*** Show the Formbased table - 'Outside' table simulates the form
loHTML.SendLn(IIF(THIS.lCenterTable,[<CENTER>],[])+CR+;
   [<TABLE BORDER="]+LTRIM(STR(THIS.nTableBorder))+;
   [" BGCOLOR="]+loHTML.HTMLColor(loContainer.BACKCOLOR,.T.)+;
   [" CELLPADDING=2>]+CR)

*** Check for Master Form - Add 'Window Title bar'
IF llMaster
   loHTML.SendLn([<TR><TD BGCOLOR="#000080"><FONT FACE="MS SANS SERIF,HELVETICA" SIZE="1" COLOR="#FFFFFF"><b>]+IIF(TYPE("loContainer.caption")="C",loContainer.CAPTION,"")+[</b></FONT></TD></TR><TR><TD>])
ELSE
   loHTML.SendLn([<TR><TD>])  && Single Cell Table which contains another table
ENDIF

*** This is the 'inside' table that contains the controls - BORDER=1 to see what the table looks like
loHTML.SendLn([<TABLE CELLPADDING=3 CELLSPACING=1 BORDER="]+LTRIM(STR(THIS.nFieldBorder))+[">])
SCAN
   lcObject=&lcobjAlias..oName
   loObject=EVAL("loContainer."+lcObject)

   lnTop=TOP
   SELECT COUNT(*) FROM (lcobjAlias) WHERE TOP=lnTop INTO ARRAY laTemp
   lnCols=laTemp[1]  && Current Row's Column Count

   lcOutput="<TR>"

   FOR x=1 TO lnCols
      lcObject=oName
      loObject=EVAL("loContainer."+lcObject)

      IF x=lnCols AND lnCols < lnMaxCols
         *** Last Item in row - padd out.
         lcOutput=lcOutput+[<TD VALIGN="TOP" COLSPAN=]+LTRIM(STR(lnMaxCols - lnCols + 1)) + THIS.InsertField(loObject) + "</TD>"
      ELSE
         lcOutput=lcOutput+[<TD VALIGN="TOP" ]+THIS.InsertField( loObject )+"</TD>"
         * EVAL(loObject"loContainer."+(lcObjAlias).oName)

         *** We have to move to the next column now, but only
         *** if we're not on the last record as the SCAN
         *** will do it otherwise.
         IF x < lnCols
            SELE (lcobjAlias)
            SKIP
         ENDIF
      ENDIF
   ENDFOR && x=1 to lnCount

   loHTML.SEND(lcOutput+"</TR>"+CR)
ENDSCAN

loHTML.SendLn([</TABLE>]+CR+;
   [</TD></TR></TABLE>]+CR+;
   IIF(THIS.lCenterTable,[<CENTER>],[]) + CR )

IF THIS.lShowCompleteForm
   loHTML.SendLn([</FORM>])
   loHTML.HTMLFooter()
ENDIF

*** Close the Work cursor
USE IN (lcobjAlias)

IF USED(lcOldAlias)
   SELE (lcOldAlias)
ENDIF

RETURN


************************************************************************
PROCEDURE InsertField
*********************
***  Modified: 10/31/96
***  Function: Gets the individual fields and inserts the tag text
***            into the form.
***    Assume:
***      Pass: loObject  -  Form control object
***    Return:
*************************************************************************
LPARAMETER loObject
LOCAL loHTMLObject, loHTMLForm
BASECLASS=loObject.BASECLASS

lcColTags=""
DO CASE
   CASE UPPER(BASECLASS) = "LABEL"
      *** Use Caption to display text on output
      loHTMLObject=CREATE("HTMLLabelControl",loObject)
      lcOutput=loHTMLObject.GetHTML()

      *!*		IF TYPE("loObject.Backcolor")="N"
      *!*		   lcColTags=" BGCOLOR="+THIS.oHTML.HTMLColor(loObject.BackColor,.T.)
      *!*		ENDIF
      IF TYPE("loObject.Alignment")="N"
         lnAlign=loObject.ALIGNMENT
         lcColTags=lcColTags+[ ALIGN="]
         DO CASE
            CASE lnAlign=0
               lcColTags=lcColTags+[LEFT]
            CASE lnAlign=1
               lcColTags=lcColTags+[RIGHT]
            CASE lnAlign=2
               lcColTags=lcColTags+[CENTER]
            OTHERWISE
               lcColTags=lcColTags+[LEFT]

         ENDCASE
         lcColTags=lcColTags+[">]
      ENDIF

   CASE UPPER(BASECLASS) = "TEXTBOX"
      loHTMLObject=CREATE("HTMLInputControl",loObject)
      lcOutput=loHTMLObject.GetHTML()
   CASE UPPER(BASECLASS) = "EDITBOX"
      loHTMLObject=CREATE("HTMLEditControl",loObject)
      lcOutput=loHTMLObject.GetHTML()
   CASE UPPER(BASECLASS) = "COMBOBOX"
      loHTMLObject=CREATE("HTMLComboControl",loObject)
      lcOutput=loHTMLObject.GetHTML()
   CASE UPPER(BASECLASS) = "COMMANDBUTTON"
      loHTMLObject=CREATE("HTMLButtonControl",loObject)
      lcOutput=loHTMLObject.GetHTML()
   CASE UPPER(BASECLASS) = "CHECKBOX"
      loHTMLObject=CREATE("HTMLCheckboxControl",loObject)
      lcOutput=loHTMLObject.GetHTML()
   CASE UPPER(BASECLASS) = "OPTIONBUTTON"
      loHTMLObject=CREATE("HTMLRadioControl",loObject)
      lcOutput=loHTMLObject.GetHTML()
   CASE UPPER(BASECLASS) = "COMMANDGROUP"
      * loHTMLObject=CREATE("HTMLCommandGroup",loObject)
      * lcOutput=loHTMLObject.GetHTML()
      *** Use Recursion to go through container!

      *** Pass in Form and HTML object
      loHTMLForm=CREATE("HTMLForm",loObject, ,.T.)

      loHTMLForm.lCenterTable=.F.
      loHTMLForm.nTableBorder=IIF(loObject.BORDERSTYLE=0,0,1)

      loHTMLForm.lShowCompleteForm=.F.

      *** Actually gen the HTML (into the loHTML object)
      loHTMLForm.ShowContainer(.T.)

      lcOutput=loHTMLForm.GetOutput()
   CASE UPPER(BASECLASS) = "OPTIONGROUP"
      * loHTMLObject=CREATE("HTMLCommandGroup",loObject)
      * lcOutput=loHTMLObject.GetHTML()
      *** Use Recursion to go through container!

      *** Pass in Form and HTML object
      loHTMLForm=CREATE("HTMLForm",loObject, ,.T.)

      loHTMLForm.lCenterTable=.F.
      loHTMLForm.nTableBorder=IIF(loObject.BORDERSTYLE=0,0,1)

      loHTMLForm.lShowCompleteForm=.F.

      *** Actually gen the HTML (into the loHTML object)
      loHTMLForm.ShowContainer(.T.)

      lcOutput=loHTMLForm.GetOutput()

      *** Recursively go down and pull the container!
   CASE UPPER(BASECLASS)="CONTAINER"
      *** Pass in Form and HTML object
      loHTMLForm=CREATE("HTMLForm",loObject)

      loHTMLForm.lCenterTable=.F.
      loHTMLForm.nTableBorder=loObject.BORDERWIDTH

      loHTMLForm.lShowCompleteForm=.F.

      *** Actually gen the HTML (into the loHTML object)
      loHTMLForm.ShowContainer(.T.)

      lcOutput=loHTMLForm.GetOutput()

   OTHERWISE
      lcOutput=""
ENDCASE

IF EMPTY(lcColTags)
   lcColTags=">"
ENDIF

RETURN lcColTags+lcOutput


************************************************************************
* HTMLForm :: GetOutput
*********************************
***  Function: This function only needs to be used if an HTML object
***            is not passed into it. Use this function to retrieve
***            accumulated HTML output.
***
***            NOTE: This method is not required if you pass in
***                  an HTML object. The obejct is updated as the
***                  HTML is built.
***    Return: String of HTML
************************************************************************
FUNCTION GetOutput
RETURN THIS.oHTML.GetOutput()
* GetOutput

ENDDEFINE
* HTMLForm
