************************************************************************
*PROCEDURE MyCode
******************
***  Modified: 06/15/96
***  Function: Processing Template for new processing programs
***      Pass: loCGI   -   wwCGI object
***    Return: nothing
*************************************************************************
LPARAMETER loCGI

#INCLUDE WCONNECT.H

*** 1 = Local  2 = Online  ( others??? NoteBook, Client etc)
#DEFINE LOCALSITE 1


#IF LOCALSITE=1
    *** TEMPLATE - DO NOT REMOVE - HTMLPAGEPATH
    #DEFINE HTMLPAGEPATH "d:\http\wconnect\"
    *** TEMPLATE - DO NOT REMOVE - HTMLPAGEPATH 
   #DEFINE DATAPATH "wwdemo\"
#ENDIF
#IF LOCALSITE=2
   #DEFINE HTMLPAGEPATH "\\WEB2\HTTP\WESTWIND\WCONNECT\"
   #DEFINE DATAPATH "wwdemo\"
#ENDIF

*** Optional HTML and graphics file path DEFINEs
*** I use these defines to avoid hardcoding paths when 
*** testing and then deploying on the server
#DEFINE HOMEPATH "/wconnect/"
#DEFINE HOMEPAGE HOMEPATH+"wconnect.htm"
#DEFINE BACKIMG HOMEPATH+"whitwav.jpg"
#DEFINE PAGEFOOT [<p><HR>]+CR+;
                 [<A HREF="http://www.west-wind.com/wwcgi.htm"><IMG SRC="/wconnect/wcpower.gif" BORDER=0 HSPACE=5 WIDTH=114 HEIGHT=42 ALIGN=LEFT ALT="Powered by Web Connection"></a>]+;
                 [<FONT SIZE=-1>Query created by <A HREF="mailto:rstrahl@west-wind.com">Rick Strahl</A><BR>]+;
                 '[<A HREF=" '+HOMEPATH+ 'wconnect.htm">Web Connection demo page</A>]'


*** Now create a process object. It's not necessary
*** to use an object here, but it makes error handling
*** document and CGI handling much easier!
loCGIProcess=CREATE("MyCodeClass",loCGI)
IF TYPE("loCGIProcess")#"O"
   *** All we can do is return...
   WAIT WINDOW NOWAIT "Unable to create CGI Processing object..."
   RETURN .F.
ENDIF

*** Call the Process Method that handles the request
loCGIProcess.Process

RETURN


*************************************************************
DEFINE CLASS MyCodeClass AS wwCGIProcess
*************************************************************
***    Author: Rick Strahl
***  Modified: 05/31/96
***  Function: Empty Template to add custom methods to
***
***            Subclassed from a generic wwCGIProcess class
***            handler which provides error handling and 
***            HTML and CGI object setup.
*************************************************************

*** Properties defined by wwCGIProcess Parent Class
*** -----------------------------------------------
*** oCGI=.NULL.
*** oHTML=.NULL.

*** Methods defined by wwCGIProcess Parent Class
*** --------------------------------------------
*** Init(oCGI)     && Initializes and checks HTML and CGI objects
*** Process        && Virtual Method that is always overridden
*** Error          && Handles errors that occur in the Process code 
*** ErrorMsg(cErrorHeader,cMessage)  && Quick Message Display


************************************************************************
* webConnectDemo :: Process
***************************
***  Function: This is the callback program file that handles
***            processing a CGI request
***      Pass: THIS.oCGI	-	Object containing CGI information
***    Return: .T. to erase Temp File .F. to keep it
************************************************************************
FUNCTION Process
LOCAL lcParameter, lcOutFile, lcIniFile, lcOldError


lcParameter=UPPER(THIS.oCGI.GetCGIParameter(2)) && Optional CGI parameters following EXE name

DO CASE
   CASE lcParameter = "DISPLAYFILE" OR lcParameter="SHOWPAGE"
      =THIS.DisplayFile(THIS.oCGI.GetCGIParameter(3),HTMLPAGEPATH)

   *** NOTE:    GENERIC ROUTING BY PARAMETER NAME
   ***          PEMSTATUS() requires VFP 3.0b or later
   CASE !EMPTY(lcParameter) AND PEMSTATUS(THIS,lcParameter,5)
      =EVALUATE("THIS."+lcParameter+"()")

   OTHERWISE
      *** Display an error message
      *** The error method creates an error document
      *** describing the error and overwriting any existing
      *** HTML output to the output document.
      *** Uses the HTMLError Message to create error doc
      THIS.ErrorMsg("The server was unable to respond "+;
         "to the CGI request.<br>"+;
         "Parameter Passed: '"+PROPER(lcParameter)+"'...",;
         "This error page is automatically called when a "+;
         "Visual FoxPro code error occurs while processing "+;
         "CGI requests.<p>It uses the wwHTML::HTMLError() method to "+;
         "output two error strings and generic server information, "+;
         "as well as overwriting existing HTML output for this request.")
ENDCASE
RETURN .T.

FUNCTION MyFirstWebRequest
LOCAL loHTML, loCGI

*** CGIProcess class contains oHTML and oCGI objects
*** Make it easier to reference these
loHTML=THIS.oHTML
loCGI=THIS.oCGI

*** Create a page header - HTML object is already created at this point
loHTML.HTMLHeader("My First Web Request")
*** Select some records from a database
SELECT company ;
   FROM TT_CUST ;
   INTO CURSOR Tquery ;
   ORDER BY Company

*** Now display the results in an HTML table
loHTML.ShowCursor()

*** For fun let's put some CGI information on the page as well
loHTML.SendPar()
loHTML.SendLn("Browser used: "+loCGI.GetBrowser()+"<BR>")
loHTML.SendLn("Query String: "+loCGI.GetCGIParameter()+"<BR>")
loHTML.SendLn("3rd Parameter: "+loCGI.GetCGIParameter(3))
loHTML.HTMLFooter(PAGEFOOT)

ENDFUNC

ENDDEFINE