************************************************************************
*PROCEDURE wwMaint
******************
***  Modified: 10/11/96
***  Function: Processes incoming wwDemo CGI requests. Called from
***            CGIMAIN.PRG using wwDemo~Task~Optional+Parms parameter.
***      Pass: loCGI   -   wwCGI object
***    Return: nothing
*************************************************************************
LPARAMETER loCGI, loExecutable

#INCLUDE WCONNECT.H

#IF LOCALSITE=1
    *** TEMPLATE - DO NOT REMOVE - HTMLPAGEPATH
    #DEFINE HTMLPAGEPATH "h:\http\wconnect\"
    *** TEMPLATE - DO NOT REMOVE - HTMLPAGEPATH 
   #DEFINE DATAPATH "c:\wwapps\wconnect\"

   *** Path of Visual FoxPro in order to allow full server recycle
   * This needs to be defined in the app specific .H file
   #DEFINE VFPPATH "D:\VFP\VFP.EXE -t CGIMAIN.PRG"

#ENDIF
#IF LOCALSITE=2
   #DEFINE HTMLPAGEPATH "\\WEB2\HTTP\WESTWIND\WCONNECT\"
   #DEFINE DATAPATH "wwdemo\"

   #DEFINE VFPPATH "c:\VFP5\VFP.EXE -t CGIMAIN.PRG"
#ENDIF
#IF LOCALSITE=3
   #DEFINE HTMLPAGEPATH "c:\HTTP\WCONNECT\"
   #DEFINE DATAPATH "c:\wwapps\wconnect\wwdemo\"

   #DEFINE VFPPATH "c:\VFP5\VFP.EXE -t CGIMAIN.PRG"
#ENDIF


*** Now create a process object. It's not necessary
*** to use an object here, but it makes error handling
*** document and CGI handling much easier!
loCGIProcess=CREATE("wwMaint",loCGI,"~","+","wwhtml")
IF TYPE("loCGIProcess")#"O"
   *** All we can do is return...
   WAIT WINDOW NOWAIT "Unable to create CGI Processing object..."
   RETURN .F.
ENDIF

*** Call the Process Method that handles the request
loCGIProcess.Process

RETURN



*************************************************************
DEFINE CLASS wwMaint AS wwCGIProcess
*************************************************************
***    Author: Rick Strahl
***  Modified: 05/31/96
***  Function: Web Connection Maintainence routines.
***            Call with "wwcgi.dll?wwMaint~SHOWLOG 
***
*************************************************************

************************************************************************
* webConnectDemo :: Process
***************************
***  Function: This is the callback program file that handles
***            processing a CGI request
***      Pass: THIS.oCGI	-	Object containing CGI information
***    Return: .T. to erase Temp File .F. to keep it
************************************************************************
FUNCTION Process
LOCAL lcParameter, lcOutFile, lcIniFile, lcOldError

loCGI=THIS.oCGI

*** Suggest you add Authentication here!!!
lcUserName=loCGI.GetCGIVar("Authenticated Username")
*!*	lcPassword=loCGI.GetCGIVar("Authenticated Password")

IF EMPTY(lcUserName)         && IIS won't do password - OR UPPER(lcPassword) # MAINTPASSWORD
    *** Send Password Dialog
   THIS.oHTML.HTMLAuthenticate(loCGI.GetServername())
   RETURN
ENDIF   

lcParameter=UPPER(THIS.oCGI.GetCGIParameter(2)) && Optional CGI parameters following EXE name

DO CASE
   CASE lcParameter = "DISPLAYFILE" OR lcParameter="SHOWPAGE"
      =THIS.DisplayFile(THIS.oCGI.GetCGIParameter(3),HTMLPAGEPATH)

   *** NOTE:    GENERIC ROUTING BY PARAMETER NAME
   ***          PEMSTATUS() requires VFP 3.0b or later
   CASE !EMPTY(lcParameter) AND PEMSTATUS(THIS,lcParameter,5)
      =EVALUATE("THIS."+lcParameter+"()")

   OTHERWISE
      *** Display an error message
      *** The error method creates an error document
      *** describing the error and overwriting any existing
      *** HTML output to the output document.
      *** Uses the HTMLError Message to create error doc
      THIS.ErrorMsg("The server was unable to respond "+;
         "to the CGI request.<br>"+;
         "Parameter Passed: '"+PROPER(lcParameter)+"'...",;
         "This error page is automatically called when a "+;
         "Visual FoxPro code error occurs while processing "+;
         "CGI requests.<p>It uses the wwHTML::HTMLError() method to "+;
         "output two error strings and generic server information, "+;
         "as well as overwriting existing HTML output for this request.")
ENDCASE

RETURN .T.

************************************************************************
* wwMaint :: ShowLog
********************
***  Function: Displays the last 300 records in the CGILOG file.
***      Pass: loCGI object
*************************************************************************
PROCEDURE Showlog
LOCAL llShowErrorLog, lnStartRecno, lnReccount

IF !USED("CGILOG")
   USE (DATAPATH + "CGILOG") in 0
ENDIF

SELE CGILOG

*** Figure out after which recnumber we can show records 
lnReccount = IIF(reccount() >= MAX_TABLE_CELLS/4, ;
                 MAX_TABLE_CELLS/4 - 1  ,;
                 reccount() ) 
lnStartRecno=reccount() - lnReccount

loHTML=THIS.oHTML
loCGI=THIS.oCGI

llShowErrorLog=IIF(ATC("ERROR",loCGI.GetCGIParameter(3))>0,.T.,.F.)

loHTML.SetAllowHTMLTables(loCGI.IsNetScape())

IF !llShowErrorLog
   loHTML.HTMLHeader("Web Connection Log Display")
   loHTML.SendLn("<b>CGILOG.DBF Record Count: "+STR(reccount())+"</b><BR>")
   
   lnReccount=IIF(lnreccount>MAX_TABLE_CELLS/4-1,MAX_TABLE_CELLS/4-1,lnReccount)
   loHTML.SendLn("Displaying last "+STR(lnreccount)+" Entries <p>")
   
*** Show hourly Log graph
lnCutoff=datetime()-86000
SELECT hour(time) as HOUR, COUNT(time) AS Hits, DAY(TIME) AS DAY ;
   FROM cgilog ;
   WHERE time > lnCutOff AND HOUR(time) > HOUR(datetime()) - 24 ;
   GROUP BY 1 ;
   ORDER BY TIME ;
   INTO Cursor TQuery

   IF _TALLY > 1
     loHTML.SendLn([<CENTER><TABLE WIDTH="100%" BGCOLOR="#EEEEEE" BORDER=2><TR><TD>])	
     loHTML.SendLn([<CENTER><H2><FONT FACE="Arial" COLOR="800000">Web Connection Hits by Hour</FONT></H2>])   
     loHTML.IEChart("BAR",1,"98%",275)
     loHTML.SendLn([</CENTER></TD></TR></TABLE>])
     loHTML.SendPar()
   ENDIF   

   *** Actual Hit Log file selection 
   SELECT time,PADR(MLINE(Request,1),40) AS Request,RemoteAddr, Duration ;
        FROM CGILOG ;
        WHERE recno()>=lnStartrecno ;
        INTO Cursor TQuery ;
        ORDER BY time DESC
   
ELSE
   loHTML.HTMLHeader("Error Log Display")
   SELECT time,Request ;
        FROM CGILOG ;
        WHERE ATC("PROCESSING ERROR",Request)>0 ;
        INTO Cursor TQuery ;
        ORDER BY time DESC
   loHTML.SendLn("<b>CGILOG.DBF Error Count: "+STR(_TALLY)+"</b><p>")

ENDIF

loHTML.ShowCursor(,,.t.,,"WIDTH=100% BORDER=3")     
loHTML.HTMLFooter()

* oCGIServer.CleanTempFiles()

USE IN TQuery

RETURN


************************************************************************
PROCEDURE ClearLog
******************
***  Modified: 01/12/96
***  Function: Clears the Access Log (CGILOG.DBF) file of records
***      Pass: loCGI
*************************************************************************
LOCAL loHTML

loCGI=THIS.oCGI
loHTML=THIS.oHTML

CLOSE DATA 
IF !OpenExclusive(DATAPATH + "CGILOG")
   loHTML.HTMLError("CGILOG file was not cleared.",;
                    "Unable to get exclusive use of the file...",;
                    loCGI.GetServerAdmin(),loCGI.GetPreviousUrl())
ELSE
   USE

   *** Append to LOGBACK file
   IF !USED("LOGBACK")
      IF !FILE(DATAPATH + "LOGBACK.DBF")
         CREATE TABLE (DATAPATH + "LOGBACK")  ;
              (    TIME        T ,;
                 REQUEST     M ,;
                 REMOTEADDR  M ,;
                 DURATION    N (5,2))
      ELSE
         USE (DATAPATH + "LOGBACK") EXCLUSIVE         
      ENDIF
      
      SELE LOGBACK
    ENDIF

    DELETE TAG ALL
    APPEND FROM CGILOG
    INDEX ON time tag time
    INDEX ON duration tag duration

    USE
      
    USE CGILOG EXCLUSIVE
    ZAP
    USE
      
    THIS.ShowLog()
ENDIF

RETURN

************************************************************************
PROCEDURE SuspendServers
************************
***  Modified: 10/06/96
***  Function: Shuts down all but one running server for maintainence
***            tasks.
*************************************************************************
LOCAL loHTML

loHTML=THIS.oHTML
loCGI=THIS.oCGI

lcMethod=UPPER(loCGI.GetCGIParameter(3))

=oCGIServer.SuspendServers(lcMethod)

IF UPPER(lcMethod)="START"
   loHTML.HTMLError("Suspend Servers",;
                    "All servers but one have been suspended.<P>"+;
                    "Please make sure you click on the Resume Servers link to "+;
                    "reactivate the suspended servers when your maintainence "+;
                    "tasks are completed!")
ENDIF
IF UPPER(lcMethod)="STOP"                    
   loHTML.HTMLError("Resume Servers",;
                    "Servers have been reactivated!")
ENDIF                    

ENDPROC

************************************************************************
PROCEDURE Sessions
******************
***  Modified: 10/08/96
***  Function: Handles session management via URLs.
***
***  The following calls are available: UPPER CASE REQUIRED in 2nd parm!
***
***       wwcgi.dll?sessions~SHOW    - Show all running sessions
***       wwcgi.dll?sessions~START   - Start additional session
***       wwcgi.dll?sessions~KILL    - Kill one Session
***       wwcgi.dll?sessions~RESTART - Kill current session and start
***                                    fresh new session
***       wwcgi.dll?sessions~CLEARSESSIONLOG 
***                                    Delete entries in the session
***                                    log file that tracks sessions.
***
***  These functions are password controlled! Set MAINTUSERNAME and
***  MAINTUSERPASSWORD to force password validation for accessing these
***  links.
*************************************************************************
LPARAMETER loCGI
LOCAL loAPI, lcType

loCGI=THIS.oCGI
loHTML=THIS.oHTML

lcParameter=loCGI.GetCGIParameter(3)
loAPI=CREATE("wwAPI")

DO CASE
   CASE lcParameter="SHOW"
      lcFile=oCGIServer.GetSessionFileName()
      IF !EMPTY(lcFile)
         SELE 0
         USE (lcFile) ALIAS wwSessions
         loHTML.HTMLHeader("Active Web Connection Sessions")
         loHTML.ShowCursor()
         loHTML.HTMLFooter()
         USE IN wwSessions
      ELSE
         loHTML.HTMLError("File does not exist...")
      ENDIF
   CASE lcParameter="RESTART" 
        *** Load another fresh copy of VFP
        lcTemp=VFPPATH
        loHTML.HTMLError("Web Connection Recycled",;
                          "Visual FoxPro Session has been stopped and restarted...")      
        RUN /N4 &lcTemp

        oCGIServer.KillSessionEntry()  && Force manually do it here!
        loHTML.Destroy()
        oCGIServer.SendCGIReturnFile() 
        CLOSE ALL
        CLEAR PROG
        QUIT
   CASE lcParameter="KILL"
        lnSessions=oCGIServer.GetSessionCount()
        IF lnSessions > 1
            loHTML.HTMLError("Web Connection Killed",;
                             "Visual FoxPro Session has been stopped and restarted...")      
            oCGIServer.KillSessionEntry()  && Force manually do it here!
            loHTML.Destroy()
            oCGIServer.SendCGIReturnFile()
            CLOSE ALL
            CLEAR PROG
            QUIT
        ELSE
            loHTML.HTMLError("Web Connection Session Not Killed",;
                             "This session is the last session running...")      
        ENDIF
   CASE lcParameter="START"
        *** Add a new session
        * loAPI.ShellExecute("D:\VFP5\VFP.exe -t surplus.prg","\SURPLUS")
        lcTemp=VFPPATH
        RUN /N4 &lcTemp 
        loHTML.HTMLError("Web Connection Session Added",;
                          "Visual FoxPro Sessions has been added...")      
   CASE lcParameter="CLEARSESSIONS"
      lcFile=oCGIServer.GetSessionFileName()
      IF !EMPTY(lcFile)
         SELE 0
         IF !OPENEXCLUSIVE(lcFile)
            USE (lcFile) ALIAS wwSessions
            DELETE ALL
         ELSE
            ZAP
         ENDIF
         USE IN wwSessions
      ENDIF

      loHTML.HTMLError("Web Connection Session File Cleared",;
                       "The session file has been cleared and the display of "+;
                       "the sessions is now potentially inaccurate. To properly "+;
                       "set up sessions again try to run the Recycle options several times.")
ENDCASE

RETURN

ENDDEFINE
